#ifndef lint
static char sccsid[] = "@(#)tiff_close.c	1.5 2/19/89";
#endif

/*
 * Copyright (c) 1988 by Sam Leffler.
 * All rights reserved.
 *
 * This file is provided for unrestricted use provided that this
 * legend is included on all tape media and as a part of the
 * software program in whole or part.  Users may copy, modify or
 * distribute this file at will.
 */

/*
 * TIFF Library.
 */
#include "tiffio.h"

TIFFClose(tif)
	TIFF *tif;
{
	static char module[] = "TIFFClose";
	TIFFDirEntry *dir = NULL;

	if (tif->tif_mode != O_RDONLY)
		/*
		 * Flush buffered data and directory (if dirty).
		 */
		TIFFFlush(tif);
	if (tif->tif_dir) {
		if (tif->tif_done)
			(*tif->tif_done)(tif);
		TIFFFreeDirectory(tif->tif_dir);
	}
	/*
	 * Dumpmode points the scanline buffer pointer
	 * into the raw buffer to avoid copy -- thus
	 * we check here to invalidate the pointer.
	 */
	if (tif->tif_rawdata <= tif->tif_scanline &&
	    tif->tif_scanline < tif->tif_rawdata+tif->tif_rawdatasize)
		tif->tif_scanline = NULL;
	if (tif->tif_scanline)
		free(tif->tif_scanline);
	if (tif->tif_rawdata)
		free(tif->tif_rawdata);
	(void) close(tif->tif_fd);
	free((char *)tif);
	return (1);
}
